//------------------------------------------------------------------------------
// File: DVBWorldSpecials.h
//------------------------------------------------------------------------------
#pragma once

#include <atlbase.h>
#include <dshow.h>

#include "..\IBdaSpecials.h"

DEFINE_GUID( GUID_TUNER_S_LOCK,
0x8bed860a, 0xa7b4, 0x4e90, 0x9d, 0xf4, 0x13, 0x20, 0xc9, 0x49, 0x22, 0x61 ) ;

class CDVBWorldSpecials : public IBdaSpecials
{
public:
	CDVBWorldSpecials(HMODULE hMySelf, CComPtr<IBaseFilter> pTunerDevice);
	virtual ~CDVBWorldSpecials(void);

	const HRESULT InitializeHook(void);
	const HRESULT Set22KHz(bool bActive);
	const HRESULT FinalizeHook(void);

	const HRESULT GetSignalState(int *pnStrength, int *pnQuality, int *pnLock);
	const HRESULT LockChannel(BYTE bySatellite, BOOL bHorizontal, unsigned long ulFrequency, BOOL bDvbS2);

	const HRESULT SetLNBPower(bool bActive);

	virtual void Release(void);

private:
	HMODULE m_hMySelf;
	HANDLE m_hTuner;
	CComPtr<IBaseFilter> m_pTunerDevice;

	////////////////////////////////////////////////////
	// Definitions for DVBWorld
	////////////////////////////////////////////////////
	typedef struct _Tuner_S_Param2 {
		GUID GUID_ID ; // = GUID_TUNER_S_LOCK
		unsigned long symbol_rate ; // Kbps
		unsigned long frequency ; // KHz
		unsigned long lnb ; // KHz
		int hv ;
		bool b22k ; // 0=off,1=on
		int diseqcPort ;
		int FEC ; // = BDA_BCC_RATE_x_x
		int Modulation ;
		int Burst ;
	} Tuner_S_Param2 ;


	// polarization
	static const int LINEAR_V = 0;
	static const int LINEAR_H = 1;

	// DiSeqC
	static const int DISEQC_PORT_A = 1;
	static const int DISEQC_PORT_B = 2;
	static const int DISEQC_PORT_C = 3;
	static const int DISEQC_PORT_D = 4;

	// Modulation
	static const int DW_MOD_DVBS1_QPSK = 1;
	static const int DW_MOD_DVBS2_QPSK = 2;
	static const int DW_MOD_DVBS2_8PSK = 3;

	// Burst
	static const int DW_BURST_UNDEFINED = 0;
	static const int DW_BURST_A = 1;
	static const int DW_BURST_B = 2;

};
