// BonTuner.cpp: CBonTuner NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include <Windows.h>
#include <atlbase.h>
#include <dshow.h>
#include <initguid.h>

#include <ks.h>
#include <ksmedia.h>
#include <bdatypes.h>
#include <bdamedia.h>

#include "..\BdaSpecials\IBdaSpecials.h"
#include "..\GrabTsForBD\IGrabTsForBD.h"
#include "BonTuner.h"
#include "DSFilterEnum.h"

#pragma comment(lib, "Strmiids.lib")
#pragma comment(lib, "ksproxy.lib")

#ifdef _DEBUG
#define printFInfo() printFiltersRefferenceCount(__LINE__)
#else
#define printFInfo() 0
#endif

#ifdef _DEBUG
int CBonTuner::FLAG = 0;
#endif

void OutputDebug(LPCSTR format, ...)
{
    char buffer[256];
    va_list ap;
    va_start(ap, format);
    vsprintf_s(buffer, sizeof(buffer), format, ap);
    OutputDebugStringA(buffer);
    va_end(ap);
}

//////////////////////////////////////////////////////////////////////
// 萔`
//////////////////////////////////////////////////////////////////////

// `[iŗL̊֐KvǂʂDB
// GUID L[ DLL 𓾂

typedef	struct _tunerSpecialDLL{
	wstring sTunerGUID;
	wstring sDLLBaseName;
} TUNER_SPECIAL_DLL;

static const TUNER_SPECIAL_DLL aTunerSpecialData[] = {
	// ̓vO}ȂƎv̂ŁAvOGUID ɐKȂ̂ŁA
	// ǉꍇ́AGUID͏ŏĂ

	/* TBS6980A */
	{L"{e9ead02c-8b8c-4d9b-97a2-2ec0324360b1}", L"TBS"},

	/* TBS6980B, Prof 8000 */
	{L"{ed63ec0b-a040-4c59-bc9a-59b328a3f852}", L"TBS"},

	/* Prof 7300, 7301, TBS 8920 */ 
	{L"{91b0cc87-9905-4d65-a0d1-5861c6f22cbf}", L"TBS"},	// 7301 ͌ŗL֐łȂĂOK

	/* TBS 6920 */
	{L"{ed63ec0b-a040-4c59-bc9a-59b328a3f852}", L"TBS"},

	/* DVBWorld 2004, 2006 */
	{L"{4c807f36-2db7-44ce-9582-e1344782cb85}", L"DVBWorld"},

	/* DVBWorld 2104 */
	{L"{5a714cad-60f9-4124-b922-8a0557b8840e}", L"DVBWorld"},

	/* DVBWorld 2005 */
	{L"{ede18552-45e6-469f-93b5-27e94296de38}", L"DVBWorld"}, // 2005 ͌ŗL֐͕KvȂ

	{L"", L""}, // terminator
};

//////////////////////////////////////////////////////////////////////
// CX^X\bh
//////////////////////////////////////////////////////////////////////
#pragma warning(disable : 4273)
extern "C" __declspec(dllexport) IBonDriver * CreateBonDriver()
{
	return (CBonTuner::m_pThis)? CBonTuner::m_pThis : ((IBonDriver *) new CBonTuner);
}
#pragma warning(default : 4273)

CBonTuner * CBonTuner::m_pThis = NULL;
HINSTANCE CBonTuner::m_hModule = NULL;

//////////////////////////////////////////////////////////////////////
// \z/
///////////////////////////////////////////////////////////////////////////////////////////////////////////
CBonTuner::CBonTuner()
: m_bOpened(FALSE), m_dwCurChannel(CBonTuner::CHANNEL_INVALID),
  m_hSemaphore(NULL), 
  m_hModuleTunerSpecials(NULL), m_pIBdaSpecials(NULL),
  m_pFilterGraph(NULL), m_pIMediaControl(NULL), m_pITuningSpace(NULL),
  m_pNetworkProvider(NULL), m_pTunerDevice(NULL), m_pCaptureDevice(NULL),
  m_pGrabber(NULL), m_pIGrabTsForBD(NULL), m_pDemux(NULL), m_pTif(NULL),
  m_hOnStreamEvent(NULL)
{
	m_pThis = this;
	ReadIniFile();
}

CBonTuner::~CBonTuner()
{
	OutputDebugStringA("~CBonTuner called.\n");
	CloseTuner();
	m_pThis = NULL;
}

/////////////////////////////////////
//
// IBonDriver2 APIs
//
/////////////////////////////////////

const BOOL CBonTuner::OpenTuner(void)
{
	::CoInitializeEx(NULL, COINIT_APARTMENTTHREADED);

	if (InitializeGraphBuilder() != S_OK)
		return FALSE;

	// tB^Ot̍쐬
	HRESULT hr;

	if (LoadTuningSpace() != S_OK) {
		if ((hr = CreateTuningSpace()) != S_OK)
			return FALSE;
	}

	if (LoadNetworkProvider() != S_OK)
		return FALSE;

	if (InitTuningSpace() != S_OK)
		return FALSE;

	if (LoadAndConnectTunerDevice() != S_OK)
		return FALSE;

	if (LoadAndConnectCaptureDevice() != S_OK)
		return FALSE;

	if (LoadAndConnectGrabDevice() != S_OK)
		return FALSE;

	if (LoadAndConnectDemux() != S_OK)
		return FALSE;
	
	if (LoadAndConnectTif() != S_OK)
		return FALSE;

	if (RunGraph() != S_OK) {
		OutputDebugStringA("RunGraph Failed.\n");
		return FALSE;
	} else {
		OutputDebugStringA("RunGraph OK.\n");
	}

	OutputDebugStringA("Build graph Successfully.\n");

	// Cxg쐬
	if((m_hOnStreamEvent = ::CreateEvent(NULL, FALSE, FALSE, NULL)) == NULL)
		return FALSE;

	// XbhN
	DWORD dwTimerThreadID = 0UL;
	if ((m_hTimerThread = ::CreateThread(NULL, 0UL, CBonTuner::TimerThread,
		this, CREATE_SUSPENDED, &dwTimerThreadID)) == NULL)
		return FALSE;

	// XbhJn
	m_bLoopIoThread = TRUE;
	if(::ResumeThread(m_hTimerThread) == 0xFFFFFFFFUL)
		return FALSE;

	m_bOpened = TRUE;
#if 0
	SetChannel(0UL, 0UL);
#endif
	return TRUE;
}

void CBonTuner::CloseTuner(void)
{
	if (!m_bOpened)
		return;
	m_bOpened = FALSE;

	StopGraph();
	CleanupGraph();
	CoUninitialize();

	// XbhIvZbg
	m_bLoopIoThread = FALSE;

	// CxgJ
	::CloseHandle(m_hOnStreamEvent);
	m_hOnStreamEvent = NULL;	

	// XbhI
	if(m_hTimerThread){
		if(::WaitForSingleObject(m_hTimerThread, 1000UL) != WAIT_OBJECT_0){
			// XbhI
			::TerminateThread(m_hTimerThread, 0UL);
		}		

		::CloseHandle(m_hTimerThread);
		m_hTimerThread = NULL;
	}

	m_dwCurChannel = CBonTuner::CHANNEL_INVALID;

	try {
		ReleaseSemaphore(m_hSemaphore, 1, NULL);
		CloseHandle(m_hSemaphore);
		m_hSemaphore = NULL;
	} catch (...) {
		OutputDebugStringA("Exception in ReleaseSemaphore.\n");
	}

	return;
}

const BOOL CBonTuner::SetChannel(const BYTE byCh)
{
	// IBonDriver (not IBonDriver2) pC^[tF[X; obsolete?
	return SetChannel(0UL, DWORD(byCh));
}

const float CBonTuner::GetSignalLevel(void)
{
	// MSDN  IBDA_SignalStatistics ̐ɂƁAQuality ł͂ȂA
	// Strength ĝB
	//
	//   get_SignalQuality M̕i 1 ` 100 ̒l擾B
	//   get_SignalStrength fVxPʂ̐M̋xl擾B 
	int nStrength;
	GetSignalState(&nStrength, NULL, NULL);
	return float(nStrength);
}

const DWORD CBonTuner::WaitTsStream(const DWORD dwTimeOut)
{
	// I`FbN
	if(!m_hOnStreamEvent || !m_bLoopIoThread)return WAIT_ABANDONED;

	// CxgVOiԂɂȂ̂҂
	const DWORD dwRet = ::WaitForSingleObject(m_hOnStreamEvent, (dwTimeOut)? dwTimeOut : INFINITE);

	switch(dwRet){
		case WAIT_ABANDONED :
			// `[iꂽ
			return WAIT_ABANDONED;

		case WAIT_OBJECT_0 :
		case WAIT_TIMEOUT :
			// Xg[擾\ or `[iꂽ
			return (m_bLoopIoThread)? dwRet : WAIT_ABANDONED;

		case WAIT_FAILED :
		default:
			// O
			return WAIT_FAILED;
	}
}

const DWORD CBonTuner::GetReadyCount(void)
{
	DWORD dwCount;
	if (m_pIGrabTsForBD)
		m_pIGrabTsForBD->get_ReadyCount(&dwCount);

	return dwCount;
}

const BOOL CBonTuner::GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	BYTE *pSrc = NULL;
	if (GetTsStream(&pSrc, pdwSize, pdwRemain)) {
		if (*pdwSize) ::CopyMemory(pDst, pSrc, *pdwSize);
		return TRUE;
	}
	return FALSE;
}

const BOOL CBonTuner::GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	if ((!m_bOpened) || (!m_pIGrabTsForBD) ||
		(m_dwCurChannel == CBonTuner::CHANNEL_INVALID))
			return FALSE;

	m_pIGrabTsForBD->get_TsStream(ppDst, pdwSize, pdwRemain);
	return TRUE;
}

void CBonTuner::PurgeTsStream(void)
{
	if (m_bOpened && m_pIGrabTsForBD)
		m_pIGrabTsForBD->purge_TsStream();
}

void CBonTuner::Release(void)
{
	OutputDebugStringA("CBonTuner::Relase called.\n");
	if (m_pIBdaSpecials) {
		m_pIBdaSpecials->Release();
		m_pIBdaSpecials = NULL;
		if (::FreeLibrary(m_hModuleTunerSpecials) == 0) {
			OutputDebugStringA("FreeLibrary failed.\n");
		} else {
			OutputDebugStringA("FreeLibrary Success.\n");
		}
	}

	delete this;
}

LPCTSTR CBonTuner::GetTunerName(void)
{
	return m_sTunerParam.sTunerName.c_str();
}

const BOOL CBonTuner::IsTunerOpening(void)
{
	return m_bOpened;
}

LPCTSTR CBonTuner::EnumTuningSpace(const DWORD dwSpace)
{
	switch(dwSpace) {
		case 0UL:
			return L"XJp[";
		default:
			return NULL;
	}
}

LPCTSTR CBonTuner::EnumChannelName(const DWORD dwSpace, const DWORD dwChannel)
{
	switch(dwSpace) {
		case 0UL:
			if (dwChannel < m_dwNumChannel)
				return m_aCh[dwChannel].szServiceName;
			else
				return NULL;
		default:
			return NULL;
	}
}

const BOOL CBonTuner::SetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	m_dwCurChannel = CBonTuner::CHANNEL_INVALID;

	if ((!m_bOpened) || (dwChannel >= m_dwNumChannel) || (dwSpace != 0))
		return FALSE;
	BOOL bRet = LockChannel(m_aCh[dwChannel].bySatellite, m_aCh[dwChannel].bHorizontal,
		m_aCh[dwChannel].dwFrequency, m_aCh[dwChannel].bDvbS2);
	::Sleep(100);
	PurgeTsStream();

	if (bRet) {
		m_dwCurChannel = dwChannel;
		return TRUE;
	}

	return FALSE;
}

const DWORD CBonTuner::GetCurSpace(void)
{
	return 0UL;
}

const DWORD CBonTuner::GetCurChannel(void)
{
	return m_dwCurChannel;
}

void CBonTuner::ReadIniFile(void)
{
	// INIt@CI[v
	WCHAR szPath[_MAX_PATH] = L"";
	GetModuleFileName(m_hModule, szPath, _MAX_PATH);

	wcscpy_s(szPath+wcslen(szPath)-3, 4, L"ini");

	WCHAR buf[255];

	//
	// Tuner ZNV
	//

	// GUID ... w肳ȂΌɎgӖB
	GetPrivateProfileString(L"TUNER", L"GUID", L"", buf, 255, szPath);
	CComBSTR bstrBuf = buf;
	bstrBuf.ToLower();
	m_sTunerParam.sTunerGUID = bstrBuf.m_str;

	// Tuner: GUI ɒ񎦂`[i ... w肳Ȃ΃ftHg
	//   gB̏ꍇA`[i𖼑Oŋʂ鎖͂łȂ
	GetPrivateProfileString(L"TUNER", L"NAME", L"DVB-S2", buf, 255, szPath);
	m_sTunerParam.sTunerName = buf;

	// `[iŗL֐gp邩ǂB
	//   ȉ INI t@CŎw\
	//     "" ... gpȂ; "AUTO" ... AUTO(default)
	//     "DLLName" ... `[iŗL֐̓DLL𒼐ڎw
	GetPrivateProfileString(L"TUNER", L"UseSpecial", L"AUTO", buf, 255, szPath);
	m_sTunerParam.sDLLBaseName = buf;

	// Channel ZNV
	m_dwNumChannel = 0;
	for (BYTE bSatNo = 3; bSatNo < 5; bSatNo++) {
		for (BYTE bTPNo = 1; bTPNo < CBonTuner::MAX_TP && m_dwNumChannel < CBonTuner::MAX_SERVICE; bTPNo++) {
			wstringstream ss;
			if (bTPNo < 10)
				ss << "JCSAT" << bSatNo << "A-TP0" << bTPNo;
			else
				ss << "JCSAT" << bSatNo << "A-TP" << bTPNo;
			wstring sTransponderName = ss.str();
			DWORD result = GetPrivateProfileString(L"CHANNEL", sTransponderName.c_str(), L"", buf, 255, szPath);

			if ((result != 7) && (result != 8))
				continue;

			// T[rXݒ肵킷Ă̂Œǉ; Aug 18,2010
			// ꂪȂ EDCBŃ`lXLłȂ
			// 2chX:573 񓙂wE
			wcscpy_s(m_aCh[m_dwNumChannel].szServiceName, sizeof m_aCh[m_dwNumChannel].szServiceName, sTransponderName.c_str()); 

			// 0ڂ 3 or 4
			if (buf[0] == '3') {
				m_aCh[m_dwNumChannel].bySatellite = 0;
			} else if (buf[0] == '4') {
				m_aCh[m_dwNumChannel].bySatellite = 1;
			} else {
				OutputDebugStringA("Format Error in readIniFile; Wrong Bird.\n");
				continue;
			}
			// 1ڂ H or V
			if ((buf[1] == 'H') || (buf[1] == 'V')) {
				m_aCh[m_dwNumChannel].bHorizontal = (buf[1] == 'H');
			} else {
				OutputDebugStringA("Format Error in readIniFile; Wrong Polarization.\n");
				continue;
			}
			// 2-6ڂ͎g([0-9])
			wstringstream iss(&buf[2]);
			iss >> m_aCh[m_dwNumChannel].dwFrequency;
			if ((m_aCh[m_dwNumChannel].dwFrequency < 12000) ||
				(m_aCh[m_dwNumChannel].dwFrequency > 13000)) {
					OutputDebugStringA("Format Error in readIniFile; Wrong Frequency.\n");
					continue;
			}
			// 7ڂ 'H'  HD ̈Ӗ
			if ((result == 8) && (buf[7] == 'H'))
				m_aCh[m_dwNumChannel].bDvbS2 = true;
			else
				m_aCh[m_dwNumChannel].bDvbS2 = false;

			m_dwNumChannel++;
		}
	}
	if (m_dwNumChannel) {
		return;
	} else {
		// XJp[v(200ch)̓Ă TP23 ftHgŃZbgĂ
		// (JCSAT-3A TP23 12.658GHz V DVB-S)
		wcscpy_s(m_aCh[0].szServiceName, sizeof m_aCh[0].szServiceName, L"Jcsat3A-TP23");
		m_aCh[0].bySatellite = 0;
		m_aCh[0].bHorizontal = FALSE;
		m_aCh[0].bDvbS2 = FALSE;
		m_aCh[0].dwFrequency = 12658;
		m_dwNumChannel = 1;
		return;
	}
}

void CBonTuner::GetSignalState(int* pnStrength, int* pnQuality, int* pnLock)
{
	if (pnStrength) *pnStrength = 0;
	if (pnQuality) *pnQuality = 0;
	if (pnLock) *pnLock = 0;

	// `[iŗL GetSignalState ΁Aۓ
	HRESULT hr;
	if ((m_pIBdaSpecials) && (hr = m_pIBdaSpecials->GetSignalState(pnStrength, pnQuality, pnLock)) != E_NOINTERFACE) {
		// E_NOINTERFACE łȂ΁AŗL֐ƂȂ̂ŁA
		// ̂܂܃^[
		return;
	}

	if (m_pTunerDevice == NULL)
		return;

	IBDA_Topology *bdaNetTop = NULL;
	if ((hr = m_pTunerDevice->QueryInterface(IID_IBDA_Topology, (void **)&bdaNetTop)) != S_OK)
		return;

	ULONG NodeTypes;
	ULONG NodeType[32];
	IUnknown *iNode;

	long longVal = 0;
	BYTE byteVal = 0;

	if ((hr = bdaNetTop->GetNodeTypes(&NodeTypes, 32, NodeType)) != S_OK) {
		OutputDebugStringA("Fail to get node type.\n");
		return;
	}

	for (unsigned int i=0; i<NodeTypes; i++) {
		hr = bdaNetTop->GetControlNode(0, 1, NodeType[i], &iNode);
		if (hr == S_OK) {
			IBDA_SignalStatistics *pSigStats;
			hr = iNode->QueryInterface(IID_IBDA_SignalStatistics, (void **)(&pSigStats));
			if (hr == S_OK) {
				longVal = 0;
				if (SUCCEEDED(hr = pSigStats->get_SignalStrength(&longVal)))
					if (pnStrength) *pnStrength = min(max(longVal,0),100);

				longVal = 0;
				if (SUCCEEDED(hr = pSigStats->get_SignalQuality(&longVal)))
					if (pnQuality) *pnQuality = min(max(longVal,0),100);

				byteVal = 0;
				if (SUCCEEDED(hr = pSigStats->get_SignalLocked(&byteVal)))
					if (pnLock) *pnLock = byteVal;

				pSigStats->Release();
				pSigStats = NULL;
			}
			iNode->Release();
			iNode = NULL;
		}
	}
	bdaNetTop->Release();
	bdaNetTop = NULL;

	return;
}

BOOL CBonTuner::LockChannel(BYTE bySatellite, BOOL bHorizontal,
							unsigned long ulFrequency, BOOL bDvbS2)
{
	// `[iŗL LockChannel ΁Aۓ
	HRESULT hr;
	if ((m_pIBdaSpecials) &&
		(hr = m_pIBdaSpecials->LockChannel(bySatellite, bHorizontal, ulFrequency, bDvbS2)) != E_NOINTERFACE) {
			// E_NOINTERFACE łȂ΁AŗL֐ƂȂ̂ŁA
			// ̒őIǏsȂĂ͂BĂ̂܂܃^[
			if (hr == S_OK) {
				OutputDebugStringA("LockChannel[Special] SUCCESS.\n");
				return TRUE;
			} else {
				OutputDebugStringA("LockChannel[Special] FAIL.\n");
				return FALSE;
			}
	}

	IDVBSTuningSpace *pIDVBSTuningSpace = NULL;
	if (hr = m_pITuningSpace->QueryInterface(IID_IDVBSTuningSpace, (void **)(&pIDVBSTuningSpace))) {
		return FALSE;
	}

	pIDVBSTuningSpace->put__NetworkType(CLSID_DVBSNetworkProvider);
	pIDVBSTuningSpace->put_HighOscillator(11200000);
	pIDVBSTuningSpace->put_LowOscillator(11200000);

	if (bySatellite == 1) // JCSAT-4
		pIDVBSTuningSpace->put_LNBSwitch(10000000);
	else
		pIDVBSTuningSpace->put_LNBSwitch(20000000);

	pIDVBSTuningSpace->put_SpectralInversion(BDA_SPECTRAL_INVERSION_AUTOMATIC);	

	// `[iŗLg[֐΁AŌĂяo
	if (!m_pIBdaSpecials || ((hr = m_pIBdaSpecials->Set22KHz(bySatellite? true: false)) == E_NOINTERFACE)) {
		// ŗL֐ȂȂ̂ŁA
	} else if (hr == S_OK) {
		OutputDebugStringA("Special Set22KHz successfully.\n");
	} else {
		OutputDebugStringA("Special Set22KHz failed.\n");
		// ̏ꍇ́Aǂ?
		//   BDA generic ȕ@Ő؂ւ邩Ȃ̂ŁA
		//     bZ[WoāÂ܂ܑs
	}

	CComPtr<ITuneRequest> pITuneRequest;
	if ((hr = pIDVBSTuningSpace->CreateTuneRequest(&pITuneRequest)) != S_OK) {
		OutputDebugStringA("Fail to create ITuneRequest.\n");
		return FALSE;
	}

	CComQIPtr<IDVBTuneRequest> pIRequest(pITuneRequest);

	CComPtr<IDVBSLocator> pILocator;
	if ((hr = pILocator.CoCreateInstance(CLSID_DVBSLocator)) != S_OK) {
		OutputDebugStringA("Fail to get IDVBSLocator.\n");
		return FALSE;
	}

	// RF M̎gݒ
	pILocator->put_CarrierFrequency(ulFrequency * 1000);
	// Õ^Cvݒ
	pILocator->put_InnerFEC(BDA_FEC_VITERBI);

	//  FEC [gƕϒ^Cvݒ
	//	OŎgoCi R{[ṼR[h [g DVB-S 3/4 S2 3/5
	//  ϒ^CvDVB-SQPSKAS2̏ꍇ 8PSK
	if (bDvbS2) {
		pILocator->put_InnerFECRate(BDA_BCC_RATE_3_5);
		pILocator->put_Modulation(BDA_MOD_8PSK);
	} else {
		pILocator->put_InnerFECRate(BDA_BCC_RATE_3_4);
		pILocator->put_Modulation(BDA_MOD_QPSK);
	}
	// OÕ^Cvݒ
	//	[h-\ 204/188 (O FEC), DVB-S2ł
	pILocator->put_OuterFEC(BDA_FEC_RS_204_188);
	// O FEC [gݒ
	pILocator->put_OuterFECRate(BDA_BCC_RATE_NOT_SET);

	// QPSK V{ [gݒ
	if (bDvbS2) {
		pILocator->put_SymbolRate(23303);
	} else {
		pILocator->put_SymbolRate(21096);
	}

	// M̕Δgݒ
	if (bHorizontal) {
		pILocator->put_SignalPolarisation(BDA_POLARISATION_LINEAR_H);
	} else {
		pILocator->put_SignalPolarisation(BDA_POLARISATION_LINEAR_V);
	}

	pIRequest->put_Locator(pILocator);

	CComQIPtr<IScanningTuner> pTuner(m_pNetworkProvider);
	if ((hr = pTuner->put_TuneRequest(pIRequest)) != S_OK) {
		OutputDebugStringA("Fail to put tune request.\n");
		return FALSE;
	}

	pIDVBSTuningSpace->Release();
	pIDVBSTuningSpace = NULL;

	int nLock;
	GetSignalState(NULL, NULL, &nLock);
	return nLock != 0;
}

HRESULT CBonTuner::InitializeGraphBuilder(void)
{
	HRESULT hr = ::CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER,
		IID_IGraphBuilder, (void **)&m_pFilterGraph);
	if (hr != S_OK) {
		OutputDebugStringA("Fail to create Graph.\n");
		return hr;
	}

	hr = m_pFilterGraph->QueryInterface(&m_pIMediaControl);
	if (hr != S_OK) {
		OutputDebugStringA("Fail to get IMediaControl.\n");
		return hr;
	}

	return S_OK;
}

void CBonTuner::CleanupGraph(void)
{
	UnloadTif();
	UnloadDemux();
	UnloadGrabDevice();
	UnloadCaptureDevice();
	UnloadTunerDevice();
	UnloadNetworkProvider();
	UnloadTuningSpace();

	ULONG ret;
	if (m_pIMediaControl)
		ret = m_pIMediaControl->Release();
	m_pIMediaControl = NULL;
	OutputDebug("ret of m_pIMediaControl->Release=%ld.\n", ret);

	if (m_pFilterGraph)
		ret = m_pFilterGraph->Release();
	m_pFilterGraph = NULL;
	OutputDebug("ret of m_pFilterGraph->Release=%ld.\n", ret);

	return;
}

HRESULT CBonTuner::LoadTuningSpace(void)
{
	ITuningSpaceContainer *pITuningSpaceContainer = NULL;

	HRESULT hr = ::CoCreateInstance(CLSID_SystemTuningSpaces, NULL, CLSCTX_INPROC_SERVER,
		IID_ITuningSpaceContainer, (void**)&pITuningSpaceContainer);

	if(FAILED(hr) || !pITuningSpaceContainer) {
		OutputDebugStringA("Failed to CoCreateInstance(CLSID_SystemTuningSpaces)\n");
		return hr;
	}

	// Get the enumerator for the collection.
	IEnumTuningSpaces *pIEnumTuningSpaces = NULL;
	hr = pITuningSpaceContainer->get_EnumTuningSpaces(&pIEnumTuningSpaces);
	if(FAILED(hr) || !pIEnumTuningSpaces) {
		OutputDebugStringA("Failed to get EnumTuningSpaces\n");
		pITuningSpaceContainer->Release();
		pITuningSpaceContainer = NULL;
		return hr;
	}

	// Loop through the collection.
	BOOL bFound = false;
	int nTuningSpaces = 0;
	ITuningSpace *pITuningSpace = NULL;
	while (pIEnumTuningSpaces->Next(1, &pITuningSpace, NULL) == S_OK) {
		if(!pITuningSpace) {
			OutputDebugStringA("FAILED: pTuningSpaceEnum->Next()\n");
			pITuningSpaceContainer->Release();
			pITuningSpaceContainer = NULL;
			return hr;
		}

		nTuningSpaces++;

		// get network type
		BSTR bstrCLSID;
		hr = pITuningSpace->get_CLSID(&bstrCLSID);
		if (wcscmp(bstrCLSID, GUID_DVBS_TUNINGSPACE) == 0) {
			SysFreeString(bstrCLSID);
			bFound = true;
			break;
		}

		// X DVB-S2 ̃`[jOԂȂꍇA
		// CreateTuningSpace ō̂T
		// ̃R[h̓eXgĂ܂
		BSTR bstrUniqueName;
		hr = pITuningSpace->get_UniqueName(&bstrUniqueName);
		if (wcscmp(bstrUniqueName, L"DD2 DVB-S") == 0) {
			SysFreeString(bstrUniqueName);
			bFound = true;
			break;
		}

		pITuningSpace->Release();
		pITuningSpace = NULL;		
		SysFreeString(bstrCLSID);
	}
	
	OutputDebug("Enumeration found %d tuning spaces", nTuningSpaces);

	m_pITuningSpace = pITuningSpace;
		
	pITuningSpaceContainer->Release();
	pITuningSpaceContainer = NULL;

	if(bFound) {
		OutputDebugStringA("Found TuningSpace");
		return S_OK;
	} else {			 
		OutputDebugStringA("FAILED: Couldn't find TuningSpace !");
		return E_FAIL;
	}
}

// ̃R[h̓eXgĂ܂
HRESULT CBonTuner::CreateTuningSpace(void)
{
	HRESULT hr = E_FAIL;
	ITuningSpaceContainer *pTuningSpaceContainer = NULL;

	// create DVB-S tuning space
	IDVBSTuningSpace  *pDVBSTuningSpace = NULL;
	hr = CoCreateInstance(CLSID_DVBSTuningSpace, NULL, CLSCTX_INPROC_SERVER, IID_IDVBSTuningSpace, (void**)&pDVBSTuningSpace);
	if(FAILED(hr) || !pDVBSTuningSpace) {
		OutputDebugStringA("Failed to Create Instance");
		pTuningSpaceContainer->Release();
		pTuningSpaceContainer = NULL;
		return hr;
	}
	
	// set unique name
	BSTR bstrTuningSpaceName = SysAllocString(L"DD2 DVB-S");
	pDVBSTuningSpace->put_UniqueName(bstrTuningSpaceName);
	SysFreeString(bstrTuningSpaceName);

	// set friendly name  (shown as Description in the registry)
	BSTR bstrFriendlyName = SysAllocString(L"DD2 DVB-S");
	if (bstrFriendlyName) {
		hr = pDVBSTuningSpace->put_FriendlyName(bstrFriendlyName); 
		SysFreeString(bstrFriendlyName);
	}
	
	// set system type
	pDVBSTuningSpace->put_SystemType(DVB_Satellite);

	// set network type
	hr = pDVBSTuningSpace->put__NetworkType(CLSID_DVBSNetworkProvider);
	if (FAILED(hr)) {
		OutputDebugStringA("BDASample: put_NetworkType failed\n");
		pDVBSTuningSpace->Release();
		pTuningSpaceContainer->Release();
		pTuningSpaceContainer = NULL;
		return hr;
	}

	// set the Frequency mapping
	BSTR bstrFreqMapping = SysAllocString(L"-1");
	if (bstrFreqMapping) {
		hr = pDVBSTuningSpace->put_FrequencyMapping(bstrFreqMapping); // not used
		SysFreeString(bstrFreqMapping);
	}

	// Set default locator
	IDVBSLocator *pDVBSLocator = NULL;
	hr = CoCreateInstance(CLSID_DVBSLocator, NULL, CLSCTX_INPROC_SERVER, IID_IDVBSLocator, (void**)&pDVBSLocator);
	if SUCCEEDED(hr) {
		pDVBSLocator->put_CarrierFrequency(-1);
		pDVBSLocator->put_SymbolRate(-1);
		pDVBSLocator->put_InnerFEC(BDA_FEC_METHOD_NOT_SET);
		pDVBSLocator->put_InnerFECRate(BDA_BCC_RATE_NOT_SET);
		pDVBSLocator->put_OuterFEC(BDA_FEC_METHOD_NOT_SET);
		pDVBSLocator->put_OuterFECRate(BDA_BCC_RATE_NOT_SET);
		pDVBSLocator->put_Modulation(BDA_MOD_NOT_SET);
		pDVBSTuningSpace->put_DefaultLocator(pDVBSLocator);
	}
	
	// get the number of tuning spaces that have been created
	LONG lCount;
	hr = pTuningSpaceContainer->get_Count(&lCount);
	
	// add the tuning space to the registry
	VARIANT varID;
	VariantInit(&varID);
	lCount++;
	varID.intVal = lCount;
	OutputDebug("Tuning Space ID:%d", lCount);
	//varID.vt = VT_INT;
	hr = pTuningSpaceContainer->Add(pDVBSTuningSpace, &varID);
	if FAILED(hr) {
		OutputDebugStringA("WARNING: pTuningSpaceContainer->Add(pDVBTuningSpace...)      Already added !");
	}
	VariantClear(&varID);
	pDVBSTuningSpace->Clone(&m_pITuningSpace);
	pDVBSTuningSpace->Release();
	if (pDVBSLocator)
		pDVBSLocator->Release();

	return S_OK;
}

void CBonTuner::UnloadTuningSpace(void)
{
	HRESULT ret;

	if (m_pITuningSpace)
		ret = m_pITuningSpace->Release();
	m_pITuningSpace = NULL;
	OutputDebug("ret of m_pITuningSpace->Release=%ld.\n", ret);
}

HRESULT CBonTuner::LoadNetworkProvider(void)
{
	HRESULT hr = E_FAIL;
	if (!m_pITuningSpace) {
		OutputDebugStringA("TuningSpace NOT SET.\n");
		return E_POINTER;
	}

	CLSID CLSIDNetworkType;
	hr = m_pITuningSpace->get__NetworkType(&CLSIDNetworkType);
	if (hr != S_OK) {
		OutputDebugStringA("Fail to get network type.\n");
		return hr;
	}

	hr = ::CoCreateInstance(CLSIDNetworkType, NULL, CLSCTX_INPROC_SERVER,
		IID_IBaseFilter, (void **)(&m_pNetworkProvider));
	if (hr != S_OK) {
		OutputDebugStringA("Fail to create network-provider.\n");
		return hr;
	}

	hr = m_pFilterGraph->AddFilter(m_pNetworkProvider, L"DVB-S Network Provider");
	if (hr != S_OK) {
		OutputDebugStringA("Fail to add network-provider into graph.\n");
		return hr;
	}

	return S_OK;
}

void CBonTuner::UnloadNetworkProvider(void)
{
	ULONG ret;

	HRESULT hr = m_pFilterGraph->RemoveFilter(m_pNetworkProvider);
	if (m_pNetworkProvider)
		ret = m_pNetworkProvider->Release();
	m_pNetworkProvider = NULL;
	OutputDebug("ret of m_pNetworkProvider->Release=%ld.\n", ret);
}

// Load tuner device
//
// ini t@CŃ`[i肳Ăꍇ͂[hB
// w肳ĂȂ KSCATEGORY_BDA_NETWORK_TUNER JeS̃`[i
// ԂɃ[h NetworkProvider ƂȂ镨
HRESULT CBonTuner::LoadAndConnectTunerDevice(void)
{
	HRESULT hr = E_FAIL;
	if (!m_pITuningSpace || !m_pNetworkProvider) {
		OutputDebugStringA("TuningSpace or NetworkProvider NOT SET.\n");
		return E_POINTER;
	}
	wstring displayName;
	wstring friendlyName;

	try {
		CDSFilterEnum dsfEnum(KSCATEGORY_BDA_NETWORK_TUNER, !_wcsicmp(m_sTunerParam.sDLLBaseName.c_str(), L"dvbworld"));
		while (dsfEnum.next() == S_OK) {
			// rp[g getFilter OɎĂ
			// 2chX4:579 ̎wE; Aug 18, 2010
			// getFilter  BindToObject 肩?

			// `[i DisplayName, FriendlyName 𓾂
			dsfEnum.getDisplayName(&displayName);
			dsfEnum.getFriendlyName(&friendlyName);

			// init@CŃ`[iw肵Ăꍇ
			if (m_sTunerParam.sTunerGUID != L"") {
				// DisplayName  GUID ܂܂邩āANO玟̃`[i
				if (displayName.find(m_sTunerParam.sTunerGUID) == string::npos)
					continue;
			}
			// rpɃZ}tHp쐬 ('\' -> '/')
			string::size_type n = 0;
			wstring semName = displayName;
			while ((n = semName.find('\\', n)) != string::npos) {
				semName.replace(n, 1, 1, '/');
			}
			
			// r
			m_hSemaphore = CreateSemaphore(NULL, 1, 1, semName.c_str());
			DWORD result = WaitForSingleObject(m_hSemaphore, 0);
			if (result != WAIT_OBJECT_0) {
				CloseHandle(m_hSemaphore);
				// L̍ssƁAłɃI[vĂgp`[iN[YĂ܂
				// 2chX4:578  ; Aug 18, 2010
				// ULONG ret = m_pTunerDevice->Release();
				// gpȂ̂Ŏ̃`[iT
				continue;
			}
				
			if (dsfEnum.getFilter(&m_pTunerDevice) == S_OK) {
				if ((hr = m_pFilterGraph->AddFilter(m_pTunerDevice, L"DVB-S2 Tuner")) != S_OK) {
					ReleaseSemaphore(m_hSemaphore, 1, NULL);
					CloseHandle(m_hSemaphore);
					m_hSemaphore = NULL;
					ULONG ret = m_pTunerDevice->Release();
					OutputDebugStringA("[P->T] Error in AddFilter\n");
					return E_FAIL;
				}
				
				// connect Ă݂
				OutputDebugStringA("A tuner Found. Trying Connect...\n");
				if ((hr = Connect("Provider->Tuner", m_pNetworkProvider, m_pTunerDevice)) == S_OK) {
					// connect 
					// Ń`[i܂̂ŁA`[iˑR[hKv`FbN
					OutputDebugStringA("Provider->Tuner Connect OK.\n");
					CheckAndSetTunerDependCode(displayName);
					// connect Ȃ̂ŁÂ܂܊֐I
					return S_OK;
				} else {
					// ɗ̂́ADVB-T/DVB-C Ȃǂ̃`[i鎞?
					// ȃ\[XāÃ`[i
					OutputDebugStringA("Provider->Tuner Connect Failed.\n");
					m_pFilterGraph->RemoveFilter(m_pTunerDevice);
					ULONG ret = m_pTunerDevice->Release();
					if (ret != 0UL)
						OutputDebug("m_pTunerDevice might be leaked, %ld\n", ret);
					ReleaseSemaphore(m_hSemaphore, 1, NULL);
					CloseHandle(m_hSemaphore);
					m_hSemaphore = NULL;
				}
			}
		}
		OutputDebugStringA("[P->T] Tuner not found.\n");
		return E_FAIL;
	} catch (...) {
		OutputDebugStringA("Fail to construct CDSFilterEnum.\n");
		return E_FAIL;
	}
}

void CBonTuner::UnloadTunerDevice(void)
{
	HRESULT hr;

	// `[iŗL֐`Ă΁AŎsĂ
	if (m_pIBdaSpecials) {
		if ((hr = m_pIBdaSpecials->FinalizeHook()) == E_NOINTERFACE) {
			// ŗLFinalize֐ȂȂ̂ŁA
		} else if (hr == S_OK) {
			OutputDebugStringA("Tuner Special Finalize successfully.\n");
		} else {
			OutputDebugStringA("Tuner Special Finalize failed.\n");
		}
		m_pIBdaSpecials = NULL;
	}

	ULONG ret;
	hr = m_pFilterGraph->RemoveFilter(m_pTunerDevice);

	if (m_pTunerDevice)
		ret = m_pTunerDevice->Release();
	m_pTunerDevice = NULL;

	OutputDebug("ret of m_pTunerDevice->Release=%ld.\n", ret);
}

// Load capture device
// Loadς݂ TunerDevice  connect ł CaptureDevice 
// T connect 
HRESULT CBonTuner::LoadAndConnectCaptureDevice(void)
{
	HRESULT hr = E_FAIL;

	if (!m_pITuningSpace || !m_pNetworkProvider || ! m_pTunerDevice) {
		OutputDebugStringA("TuningSpace, NetworkProvider or TunerDevice NOT SET.\n");
		return E_POINTER;
	}

#ifdef _DEBUG
	CBonTuner::FLAG = 1;
#endif
	try {
		CDSFilterEnum dsfEnum(KSCATEGORY_BDA_RECEIVER_COMPONENT);
		while (dsfEnum.next() == S_OK) {
			if (dsfEnum.getFilter(&m_pCaptureDevice) == S_OK) {
				if ((hr = m_pFilterGraph->AddFilter(m_pCaptureDevice, L"DVB-S2 Capture")) != S_OK) {
					ULONG ret = m_pCaptureDevice->Release();
					if (ret != 0UL)
						OutputDebug("m_pCaptureDevice might be leaked, %ld\n", ret);
#ifdef _DEBUG
					CBonTuner::FLAG = 0;
#endif
					OutputDebugStringA("[T->C] Error in AddFilter.\n");
					return hr;
				}
				// connect Ă݂
				if ((hr = Connect("Tuner->Capture", m_pTunerDevice, m_pCaptureDevice)) == S_OK) {
					OutputDebugStringA("Tuner->Captuer Connect OK.\n");
					// connect  Ȃ̂ł̂܂܏I
#ifdef _DEBUG
					CBonTuner::FLAG = 0;
#endif
					return S_OK;
				} else {
					OutputDebugStringA("Tuner->Capture Connect Failed, trying next capturedevice.\n");
					m_pFilterGraph->RemoveFilter(m_pCaptureDevice);
					ULONG ret = m_pCaptureDevice->Release();
					if (ret != 0UL)
						OutputDebug("m_pCaptureDevice might be leaked, %ld in %d\n", ret, __LINE__);
					// connect łȂΎ̃Lv`foCX
				}
			}
		}
#ifdef _DEBUG
		CBonTuner::FLAG = 0;
#endif
		OutputDebugStringA("[T->C] CaptureDevice not found.\n");
		return E_FAIL;
	} catch (...) {
		OutputDebugStringA("Fail to construct CDSFilterEnum.\n");
		return E_FAIL;
	}

}

void CBonTuner::UnloadCaptureDevice(void)
{
	ULONG ret;
	HRESULT hr = m_pFilterGraph->RemoveFilter(m_pCaptureDevice);
	if (m_pCaptureDevice)
		ret = m_pCaptureDevice->Release();
	m_pCaptureDevice = NULL;
	OutputDebug("ret of m_pCaptureDevice->Release=%ld.\n", ret);
}

HRESULT CBonTuner::LoadAndConnectGrabDevice(void)
{
	HRESULT hr = E_FAIL;

	if (!m_pITuningSpace || !m_pNetworkProvider || !m_pTunerDevice || !m_pCaptureDevice) {
		OutputDebugStringA("TuningSpace, NetworkProvider, TunerDevice or CaptureDevice NOT SET.\n");
		return E_POINTER;
	}

	hr = ::CoCreateInstance(CLSID_GrabTsForBD, NULL, CLSCTX_INPROC_SERVER,
		IID_IBaseFilter, (void **)(&m_pGrabber));
	if (hr != S_OK) {
		OutputDebugStringA("Fail to load GrabTsForBD filter.\n");
		return hr;
	}

	hr = m_pFilterGraph->AddFilter(m_pGrabber, L"GrabTsForBD");
	if (hr != S_OK) {
		OutputDebugStringA("Fail to add GrabTsForBD filter into graph.\n");
		return hr;
	}

	hr = m_pGrabber->QueryInterface(IID_IGrabTsForBD, (void **)(&m_pIGrabTsForBD));
	if (hr != S_OK) {
		OutputDebugStringA("Fail to get IGrabTsForBD.\n");
		return hr;
	}

#ifdef _DEBUG
	CBonTuner::FLAG = 1;
#endif
	hr = Connect("Capture->Grabber", m_pCaptureDevice, m_pGrabber);
#ifdef _DEBUG
	CBonTuner::FLAG = 0;
#endif
	if (hr != S_OK) {
		OutputDebugStringA("Failed to connect.\n");
		return hr;
	}

	return hr;
}

void CBonTuner::UnloadGrabDevice(void)
{
	ULONG ret;

	if (m_pIGrabTsForBD)
		ret = m_pIGrabTsForBD->Release();
	m_pIGrabTsForBD = NULL;
	OutputDebug("ret of m_pIGrabTsForBD->Release=%ld.\n", ret);

	HRESULT hr = m_pFilterGraph->RemoveFilter(m_pGrabber);

	if (m_pGrabber)
		ret = m_pGrabber->Release();
	m_pGrabber = NULL;
	OutputDebug("ret of m_pGrabber->Release=%ld.\n", ret);
}

HRESULT CBonTuner::LoadAndConnectDemux(void)
{
	HRESULT hr = E_FAIL;

	if (!m_pITuningSpace || !m_pNetworkProvider || !m_pTunerDevice || !m_pCaptureDevice
		|| !m_pGrabber) {
			OutputDebugStringA("TuningSpace, NetworkProvider, TunerDevice CaptureDevice or Grabber NOT SET.\n");
			return E_POINTER;
	}

	hr = ::CoCreateInstance(CLSID_MPEG2Demultiplexer, NULL, CLSCTX_INPROC_SERVER,
		IID_IBaseFilter, (void **)(&m_pDemux));
	if (hr != S_OK) {
		OutputDebugStringA("Fail to load MPEG2-Demultiplexer.\n");
		return hr;
	}

	hr = m_pFilterGraph->AddFilter(m_pDemux, L"MPEG2 Demultiplexer");
	if (hr != S_OK) {
		OutputDebugStringA("Fail to add MPEG2-Demultiplexer into graph.\n");
		return hr;
	}

	hr = Connect("Grabber->Demux", m_pGrabber, m_pDemux);
	if (hr != S_OK) {
		OutputDebugStringA("Fail to connect Grabber->Demux.\n");
		return hr;
	}

	return S_OK;
}

void CBonTuner::UnloadDemux(void)
{
	ULONG ret;
	HRESULT hr = m_pFilterGraph->RemoveFilter(m_pDemux);
	if (m_pDemux)
		ret = m_pDemux->Release();
	m_pDemux = NULL;
	OutputDebug("ret of m_pDemux->Release=%ld.\n", ret);
}

HRESULT CBonTuner::LoadAndConnectTif(void)
{
	HRESULT hr = E_FAIL;

	if (!m_pITuningSpace || !m_pNetworkProvider || !m_pTunerDevice 
		|| !m_pCaptureDevice || !m_pGrabber || !m_pDemux) {
			OutputDebugStringA("TuningSpace, NetworkProvider, TunerDevice CaptureDevice, Grabber or Demux NOT SET.\n");
			return E_POINTER;
	}

	try {
		CDSFilterEnum dsfEnum(KSCATEGORY_BDA_TRANSPORT_INFORMATION);
		while (dsfEnum.next() == S_OK) {
			if (dsfEnum.getFilter(&m_pTif) == S_OK) {
				if ((hr = m_pFilterGraph->AddFilter(m_pTif, L"MPEG2 Transport Information Filter")) != S_OK) {
					m_pTif->Release();
					OutputDebugStringA("[D->T] Error in AddFilter.\n");
					return hr;
				}
				// connect Ă݂
				if ((hr = Connect("Demux -> Tif", m_pDemux, m_pTif)) == S_OK) {
					OutputDebugStringA("Demux->Tif Connect OK.\n");
					// connect  Ȃ̂ł̂܂܏I
					return S_OK;
				} else {
					m_pFilterGraph->RemoveFilter(m_pTif);
					ULONG ret = m_pTif->Release();
					if (ret != 0UL)
						OutputDebug("m_pTif might be leaked, %ld.\n", ret);
					// connect łȂΎ TIF tB^
				}
			}
		}
		OutputDebugStringA("[D->T] CaptureDevice not found.\n");
		return E_FAIL;
	} catch (...) {
		OutputDebugStringA("Fail to construct CDSFilterEnum.\n");
		return E_FAIL;
	}
}

void CBonTuner::UnloadTif(void)
{
	ULONG ret;
	HRESULT hr = m_pFilterGraph->RemoveFilter(m_pTif);
	if (m_pTif)
		ret = m_pTif->Release();
	m_pTif = NULL;
	OutputDebug("ret of m_pTif->Release=%ld.\n", ret);
}

// Tuning Request 𑗂 Tuning Space 
//   Ȃ output pin oȂ`[itB^
//   炵
HRESULT CBonTuner::InitTuningSpace(void)
{
	CComQIPtr<IScanningTuner> pTuner(m_pNetworkProvider);
	CComQIPtr<IDVBSTuningSpace> pIDVBSTuningSpace(m_pITuningSpace);

	pTuner->put_TuningSpace(pIDVBSTuningSpace);

	HRESULT hr;
	CComPtr<ITuneRequest> pITuneRequest;
	if ((hr = pIDVBSTuningSpace->CreateTuneRequest(&pITuneRequest)) != S_OK) {
		OutputDebugStringA("Fail to create ITuneRequest.\n");
		return hr;
	}

	CComPtr<IDVBSLocator> pILocator;
	if ((hr = pILocator.CoCreateInstance(CLSID_DVBSLocator)) != S_OK) {
		OutputDebugStringA("Fail to get IDVBSLocator.\n");
		return hr;
	}

	pILocator->put_CarrierFrequency(-1);
	pILocator->put_SymbolRate(-1);
	pILocator->put_InnerFEC(BDA_FEC_METHOD_NOT_SET);
	pILocator->put_InnerFECRate(BDA_BCC_RATE_NOT_SET);
	pILocator->put_OuterFEC(BDA_FEC_METHOD_NOT_SET);
	pILocator->put_OuterFECRate(BDA_BCC_RATE_NOT_SET);
	pILocator->put_Modulation(BDA_MOD_NOT_SET);
	pILocator->put_SignalPolarisation(BDA_POLARISATION_NOT_SET);

	CComQIPtr<IDVBTuneRequest> pIRequest(pITuneRequest);
	pIRequest->put_Locator(pILocator);

	return S_OK;
}

// Connect pins (Common subroutine)
//  SẴsڑĐI
//
HRESULT CBonTuner::Connect(const char* pszName, IBaseFilter* pFilterUp,
						   IBaseFilter* pFilterDown)
{
	HRESULT hr = E_FAIL;

	IPin *pIPinUp;
	PIN_INFO PinInfoUp, PinInfoDown;
#ifdef _DEBUG
	if (CBonTuner::FLAG)
		printFInfo();
#endif
	IEnumPins *pIEnumPinsUp;
	if ((hr = pFilterUp->EnumPins(&pIEnumPinsUp)) != S_OK) {
		OutputDebugStringA("Fatal Error; Cannot enumerate upstream filter's pins.\n");
		return hr;
	}

#ifdef _DEBUG
	if (CBonTuner::FLAG)
		printFInfo();
#endif
	// 㗬tB^̃s̐[v
	while (pIEnumPinsUp->Next(1, &pIPinUp, 0) == S_OK) {
		if ((hr = pIPinUp->QueryPinInfo(&PinInfoUp)) != S_OK) {
			OutputDebugStringA("Fatal Error; Cannot get upstream filter's pinInfo.\n");
			pIPinUp->Release();
			pIEnumPinsUp->Release();
			return hr;
		}
#ifdef _DEBUG
		if (CBonTuner::FLAG)
			printFInfo();
#endif
		if (PinInfoUp.pFilter)
			PinInfoUp.pFilter->Release();
#ifdef _DEBUG
		if (CBonTuner::FLAG)
			printFInfo();
#endif
		// ڃs INPUTsȂ玟̏㗬s
		if (PinInfoUp.dir == PINDIR_INPUT) {
			OutputDebugStringA("This is an INPUT pin, trying next pin.\n");
			pIPinUp->Release();
#ifdef _DEBUG
			if (CBonTuner::FLAG)
				printFInfo();
#endif
			continue;
		}
#ifdef _DEBUG
		if (CBonTuner::FLAG)
			printFInfo();
#endif
		IPin *pIPinPeerOfUp;
		hr = pIPinUp->ConnectedTo(&pIPinPeerOfUp);

		if ((hr == S_OK) ||
			((FAILED(hr)) && (hr != VFW_E_NOT_CONNECTED))) {
				// pIPinUp ͐ڑς܂̓G[
				if (pIPinPeerOfUp)
					pIPinPeerOfUp->Release();
				pIPinUp->Release();
#ifdef _DEBUG
				if (CBonTuner::FLAG)
					printFInfo();
#endif
				continue;
		}

		// ȍ~͖ڑ̏ꍇB pIPinPeerOfUp  NULL łȂꍇ͂Ȃ͂?
		if (pIPinPeerOfUp) {
			OutputDebugStringA("Something wrong on pIPinPeerOfUp.\n");
			pIPinPeerOfUp->Release();
		}

		// 㗬tB^̒ڃsAEgvbgs̏ꍇ
		IEnumPins *pIEnumPinsDown;
		// tB^̃s񋓂
		if ((hr = pFilterDown->EnumPins(&pIEnumPinsDown)) != S_OK) {
			OutputDebugStringA("Fatal Error; Cannot enumerate downstream filter's pins.\n");
			pIPinUp->Release();
			pIEnumPinsUp->Release();
			return hr;
		}
#ifdef _DEBUG
		if (CBonTuner::FLAG)
			printFInfo();
#endif
		IPin *pIPinDown;
		// s̐[v
		while (pIEnumPinsDown->Next(1, &pIPinDown, 0) == S_OK) {
#ifdef _DEBUG
			if (CBonTuner::FLAG)
				printFInfo();
#endif
			if ((hr = pIPinDown->QueryPinInfo(&PinInfoDown)) != S_OK) {
				OutputDebugStringA("Fatal Error; cannot get downstream filter's pinInfo.\n");
				pIPinDown->Release();
				pIEnumPinsDown->Release();
				pIPinUp->Release();
				pIEnumPinsUp->Release();
				return hr;
			}
#ifdef _DEBUG
			if (CBonTuner::FLAG)
				printFInfo();
#endif
			if (PinInfoDown.pFilter)
				PinInfoDown.pFilter->Release();
			// 牺QueryPinInfo ̏ꍇ

			// ڃs OUTPUT sȂ玟̉s
			if (PinInfoDown.dir == PINDIR_OUTPUT) {
				pIPinDown->Release();
#ifdef _DEBUG
				if (CBonTuner::FLAG)
					printFInfo();
#endif
				continue;
			}

			IPin *pIPinPeerOfDown;
			hr = pIPinDown->ConnectedTo(&pIPinPeerOfDown);
#ifdef _DEBUG
			if (CBonTuner::FLAG)
				printFInfo();
#endif
			// tB^̒ڃsڑorG[ continue Ď̃s
			if ((hr == S_OK) ||
				((FAILED(hr)) && (hr != VFW_E_NOT_CONNECTED))) {
					if (pIPinPeerOfDown)
						pIPinPeerOfDown->Release();
					OutputDebugStringA("Target pin is already connected. Try next pin...\n");
					pIPinDown->Release();
#ifdef _DEBUG
					if (CBonTuner::FLAG)
						printFInfo();
#endif
					continue;
			}
			// ȍ~͖ڑ̏ꍇB pIPinPeerOfDown  NULL łȂꍇ͂Ȃ͂?
			if (pIPinPeerOfDown) {
				OutputDebugStringA("Something wrong on pIPinPeerOfDown.\n");
				pIPinPeerOfDown->Release();
			}
#ifdef _DEBUG
			if (CBonTuner::FLAG)
				printFInfo();
#endif

			// tB^̒ڃsCvbgs̏ꍇ
			if ((hr = m_pFilterGraph->ConnectDirect(pIPinUp, pIPinDown, NULL)) == S_OK) {
#ifdef _DEBUG
				if (CBonTuner::FLAG)
					printFInfo();
#endif
				pIPinDown->Release();
				pIPinUp->Release();
				OutputDebug("%s CBonTuner::Connect successfully.\n", pszName);
				pIEnumPinsDown->Release();
				pIEnumPinsUp->Release();
#ifdef _DEBUG
				if (CBonTuner::FLAG)
					printFInfo();
#endif
				return S_OK;
			} else {
				// RlNgłȂꍇAႤ`[ijbg̃tB^ڑ悤ƂĂꍇȂ
				OutputDebugStringA("Can't connect to unconnected pin, Maybe differenct unit?\n");
				pIPinDown->Release();
				// continue;
			}
#ifdef _DEBUG
			if (CBonTuner::FLAG)
				printFInfo();
#endif
			OutputDebugStringA("Trying next downstream pin.\n");
		} // while; ̉s
		pIEnumPinsDown->Release();
		pIPinUp->Release();
		OutputDebugStringA("Trying next upstream pin.\n");
#ifdef _DEBUG
		if (CBonTuner::FLAG)
			printFInfo();
#endif
	} // while ; ̏㗬s

	OutputDebugStringA("Can't connect.\n");
	pIEnumPinsUp->Release();
#ifdef _DEBUG
	if (CBonTuner::FLAG)
		printFInfo();
#endif
	return E_FAIL;
}

HRESULT CBonTuner::RunGraph(void)
{
	HRESULT hr = E_FAIL;
	if (!m_pIMediaControl)
		return E_POINTER;

	hr =  m_pIMediaControl->Run();
	if (hr != S_OK) {
		m_pIMediaControl->Stop();
		OutputDebugStringA("Failed to Run Graph.\n");
		return hr;
	}

	return S_OK;
}

void CBonTuner::StopGraph(void)
{
	HRESULT hr;
	if (m_pIMediaControl || m_bOpened) {
		if (hr = m_pIMediaControl->Pause() == S_OK) {
			OutputDebugStringA("IMediaControl::Pause Success.\n");
		} else {
			OutputDebugStringA("IMediaControl::Pause failed.\n");
		}

		if (hr = m_pIMediaControl->Stop() == S_OK) {
			OutputDebugStringA("IMediaControl::Stop Success.\n");
		} else {
			OutputDebugStringA("IMediaControl::Stop failed.\n");
		}
	}
}

// `[iˑR[hZbg
void CBonTuner::CheckAndSetTunerDependCode(wstring &displayName)
{
	for (int i = 0; i < sizeof aTunerSpecialData / sizeof TUNER_SPECIAL_DLL; i++) {
		if ((aTunerSpecialData[i].sTunerGUID != L"") &&
			(displayName.find(aTunerSpecialData[i].sTunerGUID)) != string::npos) {
				// INI t@C "AUTO" w(邢͖w)̏ꍇɂ́A
				// ̎̃`[iˑR[h`[ip[^ɕϐɃZbg
				if (m_sTunerParam.sDLLBaseName == L"AUTO") {
					m_sTunerParam.sDLLBaseName = aTunerSpecialData[i].sDLLBaseName;
				}
		}
	}

	if (m_sTunerParam.sDLLBaseName == L"") {
		// `[iŗL֐gȂꍇ
		return;
	}

	//  DLL [hB
	WCHAR szPath[_MAX_PATH] = L"";
	GetModuleFileName(m_hModule, szPath, _MAX_PATH);
	// tpX𕪉
	WCHAR szDrive[_MAX_DRIVE];
	WCHAR szDir[_MAX_DIR];
	WCHAR szFName[_MAX_FNAME];
	WCHAR szExt[_MAX_EXT];
	_wsplitpath_s(szPath, szDrive, szDir, szFName, szExt);

	// tH_擾
	WCHAR szDLLName[_MAX_PATH];
	swprintf_s(szDLLName, _MAX_PATH, L"%s%s%s.dll", szDrive, szDir, m_sTunerParam.sDLLBaseName.c_str());

	if ((m_hModuleTunerSpecials = ::LoadLibrary(szDLLName)) == NULL) {
		// [hłȂꍇAǂ? 
		//   fobObZ[WoāAŗL֐gȂ̂ƂĈ
		OutputDebugStringA("DLL Not found.\n");
		return;
	} else {
		OutputDebugStringA("Load Library successfully.\n");
	}

	IBdaSpecials* (*func)(CComPtr<IBaseFilter>);
	func = (IBdaSpecials* (*)(CComPtr<IBaseFilter>))::GetProcAddress(m_hModuleTunerSpecials, "CreateBdaSpecials");
	if(!func) {
		OutputDebugStringA("Cannot find CreateBdaSpecials.\n");
		::FreeLibrary(m_hModuleTunerSpecials);
		return;
	} else {
		OutputDebugStringA("CreateBdaSpecials found.\n");
	}

	m_pIBdaSpecials = func(m_pTunerDevice);

	// `[iŗL֐ŎsĂ
	//   InitializeHook ͕Kv?
	//  RXgN^̒łOK? *************************
	if (m_pIBdaSpecials)
		m_pIBdaSpecials->InitializeHook();

	return;
}

DWORD WINAPI CBonTuner::TimerThread(LPVOID pParam)
{
	// Grabber Ɏ̂͂߂ǂȂ̂ŁA100ms 
	// |[Oł܂

	CBonTuner *pThis = (CBonTuner *)pParam;

	while (pThis->m_bLoopIoThread) {
		// CxgZbg
		::SetEvent(pThis->m_hOnStreamEvent);
		::Sleep(CBonTuner::POLLINGWAIT);
	}

	return 0UL;
}

#ifdef _DEBUG
void CBonTuner::printFiltersRefferenceCount(const int lineNum)
{
	OutputDebugStringA("-----------------------------------\n");

	ULONG ret;
	if (m_pFilterGraph) {
		m_pFilterGraph->AddRef();
		ret = m_pFilterGraph->Release();
		OutputDebug("Counter of FilterGraph = %ld at %d.\n", ret, lineNum);
	}

	if (m_pIMediaControl) {
		m_pIMediaControl->AddRef();
		ret = m_pIMediaControl->Release();
		OutputDebug("Counter of IMediaControl = %ld at %d.\n", ret, lineNum);
	}

	if (m_pITuningSpace) {
		m_pITuningSpace->AddRef();
		ret = m_pITuningSpace->Release();
		OutputDebug("Counter of ITuningSpace = %ld at %d.\n", ret, lineNum);
	}

	if (m_pNetworkProvider) {
		m_pNetworkProvider->AddRef();
		ret = m_pNetworkProvider->Release();
		OutputDebug("Counter of NetworkProvider = %ld at %d.\n", ret, lineNum);
	}

	if (m_pTunerDevice) {
		m_pTunerDevice->AddRef();
		ret = m_pTunerDevice->Release();
		OutputDebug("Counter of TunerDevice = %ld at %d.\n", ret, lineNum);
	}

	if (m_pCaptureDevice) {
		m_pCaptureDevice->AddRef();
		ret = m_pCaptureDevice->Release();
		OutputDebug("Counter of CaptureDevice = %ld at %d.\n", ret, lineNum);
	}

	if (m_pGrabber) {
		m_pGrabber->AddRef();
		ret = m_pGrabber->Release();
		OutputDebug("Counter of Grabber = %ld at %d.\n", ret, lineNum);
	}

	if (m_pIGrabTsForBD) {
		m_pIGrabTsForBD->AddRef();
		ret = m_pIGrabTsForBD->Release();
		OutputDebug("Counter of IGrabTsForBD = %ld at %d.\n", ret, lineNum);
	}

	if (m_pDemux) {
		m_pDemux->AddRef();
		ret = m_pDemux->Release();
		OutputDebug("Counter of Demux = %ld at %d.\n", ret, lineNum);
	}

	if (m_pTif) {
		m_pTif->AddRef();
		ret = m_pTif->Release();
		OutputDebug("Counter of Tif = %ld at %d.\n", ret, lineNum);
	}
	OutputDebugStringA("-----------------------------------\n");

}
#endif
